package org.openl.ie.constrainer.consistencyChecking;

/**
 * <p>Title: </p>
 * <p>Description: Auxiliary class using to store information about overlapping rules</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import org.openl.ie.constrainer.IntExpArray;
import org.openl.ie.constrainer.consistencyChecking.DTChecker.Utils;


public class Overlapping {
    private Vector _overlapped = null;

    protected String[] _solutionNames = null;
    protected int[] _solutionValues = null;

    Overlapping(IntExpArray solution) {

        _solutionNames = Utils.IntExpArray2Names(solution);
        _solutionValues = Utils.IntExpArray2Values(solution);
    }

    void addRule(int num) {
        if (_overlapped == null) {
            _overlapped = new Vector();
        }
        _overlapped.add(new Integer(num));
    }

    /**
     * @return an amount of rules being satisfied with the solution returned by
     *         <code>getSolution()</code>
     * @see #getSolution()
     */
    public int amount() {
        return _overlapped.size();
    }

    /**
     * @return an array of numbers of rules overlapping in the decision table
     */
    public int[] getOverlapped() {
        int[] arr = new int[_overlapped.size()];
        Iterator iter = _overlapped.iterator();
        int i = 0;
        while (iter.hasNext()) {
            arr[i++] = ((Integer) iter.next()).intValue();
        }
        return arr;
    }

    /**
     *
     * @return the solution satisfying two or more rules in the form of a
     *         HashMap of names of the variables associated with the according
     *         values
     */
    public HashMap getSolution() {
        HashMap map = new HashMap();
        for (int i = 0; i < _solutionNames.length; i++) {
            map.put(_solutionNames[i], new Integer(_solutionValues[i]));
        }
        return map;
    }

    public String[] getSolutionNames() {
        return _solutionNames;
    }

    public int[] getSolutionValues() {
        return _solutionValues;
    }

    @Override
    public String toString() {
        String rep = "{ solution: " + getSolution() + " obeys the following rules: " + _overlapped + "}";
        return rep;
    }
}